﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----------------------------------------------------------------
        Me.Text = AppTitleAndVersion()
        ' ---------------------------------------------------------------- 
        InitPanels()
        Load_INI()
        ComboBox_VideoInputDevice_InitWithCurrentDeviceName()
        SetDecodeTypes()
        UpdateAllPanels()
        ' ---------------------------------------------------------------- CAPTURE
        CaptureStart()
        ProcessImage_SetParams()
        SetEnableParams()
        ' ---------------------------------------------------------------- DOCK
        If Form_VideoInControls_VisibleAtStart Then
            Form_VideoInControls.Show(Me)
        Else
            Form_VideoInControls.Show(Me)
            Form_VideoInControls.Visible = False
        End If
        DockAllWindows()
        ' ----------------------------------------------------------------
        ToolStrip1.Renderer = New ToolStripButtonRenderer
        ' ---------------------------------------------------------------- Main Timer
        Timer1.Interval = 50
        Timer1.Start()
        Timer2.Interval = 200
        Timer2.Start()

        DecodeThread_Start()
        ' ----------------------------------------------------------------
        SetDefaultFocus()
        EventsAreEnabled = True
        ' ---------------------------------------------------------------- SHOW
        Refresh()
        Forms_FadeTo(1, 400)


        ' TODO - TEST TStrings
        'Dim sw As Stopwatch = New Stopwatch
        'sw.Start()
        ''Slots.WriteSlot(1, 12)
        ''StringSlots.WriteString(1, "1234567890")
        'StringSlots.WriteString(1, StrDup(4000, "A"c))
        ''Text = StringSlots.ReadString(1)
        'Text = sw.Elapsed.TotalMilliseconds.ToString

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Not EventsAreEnabled Then Return
        CloseProgram()
    End Sub

    Private Sub CloseProgram()
        Save_INI()
        EventsAreEnabled = False
        Forms_FadeTo(0, 500)
        Me.Refresh()
        Timer1.Stop()
        Capture_STOP()
        DecodeThread_Stop()
        Form_VideoInControls.Close()
        Me.Close()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
        DockAllWindows()
    End Sub

    Private Sub Form1_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not EventsAreEnabled Then Return
        DockAllWindows()
    End Sub

    Private Sub SetDefaultFocus()
        PBox_Camera.Focus()
    End Sub

    Friend Sub PictureBox1_Clear()
        PBox_Camera.Image = PBox_Camera.InitialImage
    End Sub

    Friend Sub DockAllWindows()
        Form_VideoInControls.SetSnap()
    End Sub

    Private Sub OpenCloseFormVideoInControls()
        If Form_VideoInControls.Visible Then
            Form_VideoInControls.Visible = False
        Else
            Form_VideoInControls.Visible = True
            Me.Focus()
        End If
        DockAllWindows()
    End Sub

    Private Sub CaptureStart()
        Capture_INIT(VideoInDevice)
        If VideoCaptureDevice_Is_VFW() Then
            Capture_ConnectFiltersAndRun()
        Else
            Capture_SetVideoFormatParams()
        End If
    End Sub


    ' ===================================================================================
    '   ToolStrip Gradient
    ' ===================================================================================
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub

    ' ===================================================================================
    '   ToolStrip PressedButton color
    ' ===================================================================================
    Class ToolStripButtonRenderer
        Inherits System.Windows.Forms.ToolStripProfessionalRenderer
        Protected Overrides Sub OnRenderButtonBackground(ByVal e As ToolStripItemRenderEventArgs)
            Dim btn As ToolStripButton = CType(e.Item, ToolStripButton)
            If btn IsNot Nothing AndAlso btn.CheckOnClick AndAlso btn.Checked Then
                Dim bounds As Rectangle = New Rectangle(0, 0, e.Item.Width - 1, e.Item.Height - 1)
                Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                               Color.Gold, _
                                                               Color.FromArgb(250, 250, 250), _
                                                               Drawing2D.LinearGradientMode.Vertical)
                e.Graphics.FillRectangle(brush, bounds)
                e.Graphics.DrawRectangle(Pens.Orange, bounds)
            Else
                MyBase.OnRenderButtonBackground(e)
            End If
        End Sub
    End Class

    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub


   

    ' =======================================================================================
    '   TOOLSTRIP
    ' =======================================================================================
    Private Sub Tool_VideoInControls_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_VideoControls.Click
        OpenCloseFormVideoInControls()
    End Sub
    Private Sub ToolStrip1_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStrip1.MouseEnter
        Me.Focus() ' with this the toolstrip responds always at the first click
    End Sub

    ' ==============================================================================================================
    '   COMBO BOX - VIDEO INPUT
    ' ==============================================================================================================
    Private Sub ComboBox_VideoInputDevice_InitWithCurrentDeviceName()
        Combo_Init(ComboBox_VideoInputDevice, VideoInDevice)
    End Sub
    Private Sub ComboBox_VideoInputDevice_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoInputDevice.DropDownClosed
        SetDefaultFocus()
    End Sub
    Private Sub ComboBox_VideoInputDevice_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox_VideoInputDevice.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        VideoInDevice = Combo_GetValue(ComboBox_VideoInputDevice)
        Timer1.Stop()
        Application.DoEvents()
        Capture_STOP()
        Application.DoEvents()
        Capture_INIT(VideoInDevice)
        Capture_ConnectFiltersAndRun()
        Timer1.Start()
        SetDefaultFocus()
        Save_INI()
        If Form_VideoInControls.Visible Then
            Form_VideoInControls.UpdateAllValues()
            Form_VideoInControls.Focus()
        End If
    End Sub
    Private Sub ComboBox_VideoInputDevice_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoInputDevice.DropDown
        Dim fnames() As String
        fnames = EnumFiltersByCategory(FilterCategory.VideoInputDevice)
        With ComboBox_VideoInputDevice
            .Items.Clear()
            For Each fltName As String In fnames
                .Items.Add(fltName)
            Next
            Combo_SetIndex_FromString(ComboBox_VideoInputDevice, VideoInDevice)
        End With
    End Sub

    ' ==============================================================================================================
    '   FLIP PARAMS
    ' ==============================================================================================================
    Private Sub FlipParams_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_FlipX.LostFocus, _
                                                                                                         chk_FlipY.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub FlipParams_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_FlipX.CheckedChanged, _
                                                                                                       chk_FlipY.CheckedChanged
        If Not EventsAreEnabled Then Return
        ProcessImage_SetParams()
    End Sub

    ' ==============================================================================================================
    '   COMBO CODE TYPE
    ' ==============================================================================================================
    Private Sub lbl_Decoder1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbl_Decoder1.Click
        cmb_CodeType.DroppedDown = True
    End Sub
    Private Sub cmb_CodeType_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_CodeType.DropDown
        cmb_CodeType.ItemHeight = 16
    End Sub
    Private Sub cmb_CodeType_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_CodeType.DropDownClosed
        cmb_CodeType.ItemHeight = 12
        SetDecodeTypes()
        Save_INI()
    End Sub
    Private Sub SetDecodeTypes()
        Decoder_SetTypes(cmb_CodeType.Text)
        lbl_Decoder1.Text = GetDecoderComments(cmb_CodeType.Text)
    End Sub

    ' ==============================================================================================================
    '   BUTTONS AND COMMANDS
    ' ==============================================================================================================
    Private Sub EnableParams_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
                                                                                                           txt_FirstSlot.LostFocus, _
                                                                                                           txt_RepeatHz.LostFocus, _
                                                                                                           txt_EnableDecoderSlot.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub EnableParams_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
                                                                                                           txt_FirstSlot.TextChanged, _
                                                                                                           txt_RepeatHz.TextChanged, _
                                                                                                           txt_EnableDecoderSlot.TextChanged
        If Not EventsAreEnabled Then Return
        SetEnableParams()
    End Sub
    Private Sub SetEnableParams()
        DecodeThread_SetFrequency(txt_RepeatHz.NumericValueInteger)
    End Sub


    ' ==============================================================================================================
    '   CAPTURE TIMER
    ' ==============================================================================================================
    Private Timer1_Working As Boolean = False
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        ProcessImage_ToUserInterface()
    End Sub

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        ' ---------------------------------------------------------- test enable decoder slot
        If txt_EnableDecoderSlot.NumericValueInteger > 0 Then
            DecodeThreadEnabled = Slots.ReadSlot(txt_EnableDecoderSlot.NumericValueInteger) > 500
        Else
            DecodeThreadEnabled = True
        End If
        ' ---------------------------------------------------------- show label text
        StatusLabel1.Text = DecodedText
        ' ---------------------------------------------------------- decode to slots and stringfile
        DecodeToSlots()
        ' ---------------------------------------------------------- debug
        'Label_DecodeMillisec.Visible = True
        'Label_DecodeMillisec.Text = DecodeMillisec.ToString + " mS"
    End Sub

    Private Sub DecodeToSlots()
        Static OldDecodedText As String = ""
        If DecodedText <> OldDecodedText Then
            OldDecodedText = DecodedText
            ' ----------------------------------- Decode "Slots nnnn nn nnn.nn nnn"
            If txt_FirstSlot.NumericValueInteger >= 0 Then
                Dim i As Int32 = DecodedText.ToLower.IndexOf("slots")
                If i > 1 Then
                    Dim s As String = Mid(DecodedText, i + 6)
                    s = ReplaceMultipleSpacesAndTabAndTrim(s)
                    Dim sa() As String = s.Split(" "c)
                    For j As Int32 = 0 To sa.Length - 1
                        Slots.WriteSlot(txt_FirstSlot.NumericValueInteger + j, CSng(Val(sa(j))))
                    Next
                End If
            End If
            ' ----------------------------------- Write the QRcode text to SlotText
            If txt_SlotText.NumericValueInteger >= 0 Then
                StringSlots.WriteString(txt_SlotText.NumericValueInteger, DecodedText)
            End If
        End If
    End Sub


    ' ===================================================================================================
    '  PANELS 
    ' ===================================================================================================
    Private PanelHeight(3) As Int32

    Private Sub InitPanels()
        PanelHeight(1) = GroupBox1.Height
        PanelHeight(2) = GroupBox2.Height
        PanelHeight(3) = GroupBox3.Height
    End Sub

    Private Sub GroupBox_Click(ByVal sender As Object, ByVal e As EventArgs) Handles GroupBox1.Click, _
                                                                                     GroupBox2.Click, _
                                                                                     GroupBox3.Click
        Dim gbox As GroupBox = CType(sender, GroupBox)
        If gbox.PointToClient(MousePosition).Y > 20 Then Return
        ToggleGboxHeight(gbox)
        UpdateAllPanels()
    End Sub

    Private Sub ToggleGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height > 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub SetGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height <= 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub UpdateAllPanels()
        If Me.WindowState = FormWindowState.Minimized Then Return
        ' --------------------------------------- Ensure the correct height also if INI is not ok
        SetGboxHeight(GroupBox1)
        SetGboxHeight(GroupBox2)
        SetGboxHeight(GroupBox3)
        ' --------------------------------------- Set the vertical positions
        GroupBox2.Top = GroupBox1.Bottom + 6
        GroupBox3.Top = GroupBox2.Bottom + 6
        ' --------------------------------------- Set the Form minimum height
        Dim topSize As Int32 = Me.Size.Height - Me.ClientSize.Height
        Dim MinHeight As Int32 = GroupBox3.Bottom + topSize + 71
        If MinHeight < 100 Then MinHeight = 100
        Me.MinimumSize = New Size(Me.MinimumSize.Width, MinHeight)
    End Sub

End Class
