﻿Module DecodeThread

    Private m_FastThread As Threading.Thread
    Friend TerminateThread As Boolean

    Friend DecodeThreadEnabled As Boolean
    Friend DecodeThreadBitmap As Bitmap
    Friend DecodeThreadMilliseconds As Int32 = 100
    Friend DecodedText As String
    Friend DecodeMillisec As Long

    Friend Sub DecodeThread_Start()
        ' --------------------------------------------------------- start the Thread 
        m_FastThread = New Threading.Thread(AddressOf Thread_Execute)
        ' --------------------------------------------------------- make the thread as background thread.
        m_FastThread.IsBackground = True
        ' --------------------------------------------------------- set the Priority of the thread.
        m_FastThread.Priority = Threading.ThreadPriority.AboveNormal
        ' --------------------------------------------------------- start the thread
        TerminateThread = False
        m_FastThread.Start()
    End Sub

    Friend Sub DecodeThread_Stop()
        If m_FastThread Is Nothing Then Return
        ' --------------------------------------------- try to join the thread
        TerminateThread = True
        m_FastThread.Join(10)
        Try
            ' --------------------------------------------- test 
            For i As Int32 = 1 To 20
                If Not m_FastThread.IsAlive Then Exit For
                Threading.Thread.Sleep(10)
                Application.DoEvents()
            Next
            ' --------------------------------------------- eventually abort
            If m_FastThread.IsAlive Then
                'MessageBox.Show("ExecutionThread not closed correctly.", _
                '                "Message from Automation", _
                '                MessageBoxButtons.OK, MessageBoxIcon.Warning)
                m_FastThread.Abort()
            End If
        Catch
        End Try
        ' ---------------------------------------------
        m_FastThread = Nothing
    End Sub

    Friend Sub DecodeThread_SetFrequency(ByVal FrequencyHz As Int32)
        If FrequencyHz > 0 Then
            DecodeThreadMilliseconds = 1000 \ FrequencyHz
        Else
            DecodeThreadMilliseconds = 1000
        End If
    End Sub

    Private sw As Stopwatch = New Stopwatch
    Private Sub Thread_Execute()
        Do
            sw.Reset()
            sw.Start()
            '
            If DecodeThreadEnabled Then
                DecodedText = Decode(DecodeThreadBitmap)
            Else
                DecodedText = ""
            End If
            '
            DecodeMillisec = sw.ElapsedMilliseconds
            Threading.Thread.Sleep(DecodeThreadMilliseconds)
        Loop Until TerminateThread
    End Sub

End Module
