
Module Module_Utils

    ' =======================================================================================
    '  Utils
    ' =======================================================================================
    Friend Sub SleepMyThread(ByVal TimeMillisec As Int32)
        System.Threading.Thread.Sleep(TimeMillisec)
    End Sub
    Friend Function Shell_NormalFocus(ByVal path As String) As Int32
        Try
            Return Shell(path, AppWinStyle.NormalFocus)
        Catch
            MsgBox("Cannot open the path: " & vbCr & path, MsgBoxStyle.Information)
            Return 0
        End Try
    End Function
    Friend Function MouseButtonLeftPressed() As Boolean
        Return (Control.MouseButtons And Windows.Forms.MouseButtons.Left) <> Windows.Forms.MouseButtons.None
    End Function
    Friend Function MouseButtonRightPressed() As Boolean
        Return (Control.MouseButtons And Windows.Forms.MouseButtons.Right) <> Windows.Forms.MouseButtons.None
    End Function

    Friend Sub Swap(ByRef n1 As Single, ByRef n2 As Single)
        Dim n3 As Single = n2
        n2 = n1
        n1 = n3
    End Sub
    Friend Sub Swap(ByRef n1 As Double, ByRef n2 As Double)
        Dim n3 As Double = n2
        n2 = n1
        n1 = n3
    End Sub
    Friend Sub Swap(ByRef n1 As Int32, ByRef n2 As Int32)
        Dim n3 As Int32 = n2
        n2 = n1
        n1 = n3
    End Sub

    ' ==============================================================
    '  REPLACE MULTIPLE SPACES and TABS and TRIM  
    '  (3..5 uS for Strings with 32 chars)
    ' ============================================================== 
    Friend Function ReplaceMultipleSpacesAndTabAndTrim(ByVal s As String) As String
        If s = "" Then Return s
        s = s.Replace(vbTab, " ")
        While s.Contains("  ")
            s = s.Replace("  ", " ")
        End While
        Return s.Trim
    End Function

    ' ==============================================================
    '  REPLACE MULTIPLE SPACES and TABS
    '  (3..5 uS for Strings with 32 chars)
    '  (same time that the trim version)
    ' ============================================================== 
    Friend Function ReplaceMultipleSpacesAndTabs(ByVal s As String) As String
        s = s.Replace(vbTab, " ")
        While s.Contains("  ")
            s = s.Replace("  ", " ")
        End While
        Return s
    End Function


    ' ==============================================================================================================
    '   COMBO FUNCTIONS
    ' ==============================================================================================================
    Friend Sub Combo_Init(ByVal combo As ComboBox, ByVal str As String)
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        If str = Nothing Then str = ""
        With combo
            .Items.Clear()
            .Items.Add(str)
            .SelectedIndex = 0
        End With
        EventsAreEnabled = old
    End Sub
    Friend Sub Combo_SetIndex_FromString(ByVal combo As ComboBox, ByVal str As String)
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        If str = Nothing Then str = ""
        With combo
            For i As Int32 = 0 To .Items.Count - 1
                If .Items(i).ToString = str Then
                    .SelectedIndex = i
                    Exit For
                End If
            Next
        End With
        EventsAreEnabled = old
    End Sub
    Friend Function Combo_GetValue(ByVal combo As ComboBox) As String
        If combo.SelectedIndex < 0 Then Return ""
        Return combo.Items(combo.SelectedIndex).ToString()
    End Function
    Friend Sub Combo_SetIndex(ByVal combo As ComboBox, ByVal index As Int32)
        If combo.Items.Count < 1 Then Exit Sub
        If index < 0 Then index = 0
        If index > combo.Items.Count - 1 Then index = combo.Items.Count - 1
        combo.SelectedIndex = index
    End Sub
    Friend Sub Combo_InitFromEnum(ByVal combo As ComboBox, ByVal enumType As Type) ' use GeType(enum)
        For Each s As String In [Enum].GetNames(enumType)
            combo.Items.Add(s)
        Next
    End Sub


    ' =============================================================================================
    '  ASYNC KEY and MOUSE STATE
    ' =============================================================================================
    Private Const PRESSED_NOW As Int32 = &H8000
    Private Const PRESSED_AFTER_PREVIOUS_CALL As Int32 = &H1
    Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Int32) As Int16
    Friend Function KeyFromPreviousCall(ByVal k As Int32) As Boolean
        KeyFromPreviousCall = (GetAsyncKeyState(k) And PRESSED_AFTER_PREVIOUS_CALL) <> 0
    End Function
    Friend Function Key(ByVal k As Int32) As Boolean
        Key = (GetAsyncKeyState(k) And PRESSED_NOW) <> 0
    End Function
    'Friend Sub WaitMouseOff()
    '    While Key(Keys.LButton) Or Key(Keys.MButton) Or Key(Keys.RButton)
    '        SleepMyThread(1)
    '    End While
    'End Sub
    'Friend Sub WaitKeyOff(ByVal WaitKey As Long)
    '    Do
    '        SleepMyThread(1)
    '    Loop Until Not Key(WaitKey)
    'End Sub


    ' =======================================================================================================
    '   REDIM PRESERVE BIDIMENSIONAL STRING ARRAY
    ' =======================================================================================================
    Friend Sub RedimPreserve_2D_Array(ByRef ar(,) As String, ByVal rowUpperIdx As Int32, ByVal colUpperIdx As Int32)
        Dim newArray(rowUpperIdx, colUpperIdx) As String
        Dim minRows As Integer = Math.Min(rowUpperIdx + 1, ar.GetLength(0))
        Dim minCols As Integer = Math.Min(colUpperIdx + 1, ar.GetLength(1))
        For i As Int32 = 0 To minRows - 1
            For j As Int32 = 0 To minCols - 1
                newArray(i, j) = ar(i, j)
            Next
        Next
        ar = newArray
    End Sub


    ' =======================================================================================================
    '   FadeIn and FadeOut 
    ' =======================================================================================================
    Friend Sub Forms_FadeTo(ByVal FinalValue As Double, ByVal TimeMillisec As Double)
        Try
            If TimeMillisec < 1 Then TimeMillisec = 1
            Dim v As Double
            Dim k As Double
            Dim date1 As Date
            '
            Dim StartValue As Double = Form1.Opacity
            '
            Application.DoEvents()
            System.Threading.Thread.Sleep(1)
            date1 = Date.Now
            Do
                k = Date.Now.Subtract(date1).TotalMilliseconds / TimeMillisec
                If k > 1 Then k = 1
                v = StartValue + (FinalValue - StartValue) * k
                If FinalValue = 0 Then
                    v = v * 0.5
                End If
                Form1.Opacity = v
                Form_VideoInControls.Opacity = v
                System.Threading.Thread.Sleep(20)
                'Debug.Print(v.ToString)
            Loop Until k >= 1
        Catch
            Form1.Opacity = 1
            Form_VideoInControls.Opacity = 1
        End Try
    End Sub


    ' ===============================================================
    '  WINDOWS SCHEDULER PRECISION
    ' =============================================================== 
    '<System.Runtime.InteropServices.DllImport("winmm.dll")> _
    'Private Function timeBeginPeriod(ByVal uPeriod As Int32) As Int32
    'End Function
    '<System.Runtime.InteropServices.DllImport("winmm.dll")> _
    'Private Function timeEndPeriod(ByVal uPeriod As Int32) As Int32
    'End Function
    'Friend Sub MillisecondPrecision_Start()
    '    timeBeginPeriod(1)
    'End Sub
    'Friend Sub MillisecondPrecision_End()
    '    timeEndPeriod(1)
    'End Sub


    'Public Function VarPtr(ByVal e As Object) As IntPtr
    '    Dim GC As System.Runtime.InteropServices.GCHandle = _
    '    System.Runtime.InteropServices.GCHandle.Alloc(e, System.Runtime.InteropServices.GCHandleType.Pinned)
    '    Dim GC2 As Int32 = GC.AddrOfPinnedObject.ToInt32
    '    GC.Free()
    '    Return CType(GC2, IntPtr)
    'End Function

    'Public Function VarPtr_Int(ByVal e As Object) As Int32
    '    Dim GC As System.Runtime.InteropServices.GCHandle = _
    '    System.Runtime.InteropServices.GCHandle.Alloc(e, System.Runtime.InteropServices.GCHandleType.Pinned)
    '    Dim GC2 As Int32 = GC.AddrOfPinnedObject.ToInt32
    '    GC.Free()
    '    Return GC2
    'End Function

    ' ----------------------------------------------------------------------------
    '  COUNT DIFFERENT PIXELS
    ' ----------------------------------------------------------------------------
    Friend Function CountDifferentPixels(ByVal bmp1 As Bitmap, _
                                         ByVal bmp2 As Bitmap, _
                                         ByVal limit As Int32) As Int32
        '
        Dim Counter As Int32 = 0
        Try
            If bmp1.Width <> bmp2.Width Or bmp1.Height <> bmp2.Height Then
                Return Integer.MaxValue
            End If
            Dim W As Integer = bmp1.Width
            Dim H As Integer = bmp1.Height
            '
            Dim A1, A2 As Int32
            '
            Dim bd1 As Imaging.BitmapData = bmp1.LockBits(New Rectangle(0, 0, W, H), _
                                                          Imaging.ImageLockMode.ReadWrite, _
                                                          bmp1.PixelFormat)
            Dim bd2 As Imaging.BitmapData = bmp2.LockBits(New Rectangle(0, 0, W, H), _
                                                          Imaging.ImageLockMode.ReadWrite, _
                                                          bmp1.PixelFormat)
            ' 
            Dim bytes1 As Integer = bd1.Stride * H
            Dim bytes2 As Integer = bd2.Stride * H
            '
            Dim rgbvalues1(bytes1) As Byte
            Dim rgbvalues2(bytes1) As Byte
            '
            System.Runtime.InteropServices.Marshal.Copy(bd1.Scan0, rgbvalues1, 0, bytes1)
            System.Runtime.InteropServices.Marshal.Copy(bd2.Scan0, rgbvalues2, 0, bytes2)
            '
            bmp1.UnlockBits(bd1)
            bmp2.UnlockBits(bd1)
            '
            For x As Int32 = 0 To bytes1 - 4 Step 4
                A1 = CInt(rgbvalues1(x + 2)) + CInt(rgbvalues1(x + 1)) + CInt(rgbvalues1(x + 0))
                A2 = CInt(rgbvalues2(x + 2)) + CInt(rgbvalues2(x + 1)) + CInt(rgbvalues2(x + 0))
                If Math.Abs(A1 - A2) > limit Then
                    Counter += 1
                End If
            Next
            
        Catch
        End Try
        Return Counter
    End Function

   
End Module
